﻿using System.Data.SQLite;

namespace TestProject
{
    /// <summary>
    /// 평균 함수
    /// </summary>
    [SQLiteFunction(Arguments = 1, FuncType = FunctionType.Aggregate, Name = "AVERAGE")]
    public class AVERAGE : SQLiteFunction
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 카운트
        /// </summary>
        private int count = 0;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 단계별 처리하기 - Step(argumentArray, stepNumber, contextData)

        /// <summary>
        /// 단계별 처리하기
        /// </summary>
        /// <param name="argumentArray">인자 배열</param>
        /// <param name="stepNumber">단계 변호</param>
        /// <param name="contextData">컨텍스트 데이터</param>
        public override void Step(object[] argumentArray, int stepNumber, ref object contextData)
        {
            if(contextData == null)
            {
                contextData = 0.0;

                this.count = 0;
            }

            contextData = (double)contextData + (double)argumentArray[0];

            this.count++;
        }

        #endregion
        #region 최종 처리하기 - Final(contextData)

        /// <summary>
        /// 최종 처리하기
        /// </summary>
        /// <param name="contextData">컨텍스트 데이터</param>
        /// <returns>결과</returns>
        public override object Final(object contextData)
        {
            return (double)contextData / count;
        }

        #endregion
    }
}